<template>
    <div class="row">
        <div class="col-12">
            <BudgetNavigation/>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <h4>Бюджетные коды</h4>
        </div>
    </div>
    <div class="row">
        <div class="col-6">
            <BudgetCodeTypeSelector
                v-model:codeType="codeType"
                @change="codesListUpdateRequired = true"/>
        </div>
        <div class="col-6">
            <BudgetShowInactiveSelector
                v-model:showInactive="showInactive"
                @change="codesListUpdateRequired = true"/>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <BudgetCodeAdd
                :municipalityId="municipalityId"
                :codeType="codeType"
                v-model:isEditPossible="isEditPossible"
                @codeAdded="codesListUpdateRequired = true"/>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <BudgetCodesTable
                :municipalityId="municipalityId"
                :codeType="codeType"
                :showInactive="showInactive"
                :codesList="codesList"
                v-model:isEditPossible="isEditPossible"
                v-model:codesListUpdateRequired="codesListUpdateRequired"
                @tableUpdated="codesListUpdateRequired = false"/>
        </div>
    </div>
</template>

<script>
    import BudgetNavigation from '../BudgetNavigation'
    import BudgetCodeTypeSelector from './BudgetCodeTypeSelector'
    import BudgetShowInactiveSelector from '../BudgetShowInactiveSelector'
    import BudgetCodeAdd from './BudgetCodeAdd'
    import BudgetCodesTable from './BudgetCodesTable'
    import { BudgetCodesService } from '../../services/budgetCodesService'
    import { defaultHandleErrorFunction } from '@/services/http-common'
    import { codeTypes } from '@/services/values'

    export default {
        name: 'BudgetCodesList',
        components: {
            BudgetNavigation,
            BudgetCodeTypeSelector,
            BudgetShowInactiveSelector,
            BudgetCodeAdd,
            BudgetCodesTable
        },
        props: {
            municipalityId: Number
        },
        data() {
            return {
                codeType: codeTypes.INCOME,
                showInactive: true,
                isEditPossible: true,
                codesList: [],
                codesListUpdateRequired: true
            }
        },
        methods: {
            checkUpdateRequired(){
                if (this.codesListUpdateRequired) {
                    this.updateCodesList();
                    this.codesListUpdateRequired = false;
                }
            },
            updateCodesList() {
                budgetCodesService
                    .get(this.municipalityId, this.codeType, this.showInactive)
                    .then(response => {
                        this.codesList = response
                            .data
                            .sort((a, b) => a.number.replace(/\s/g, '').localeCompare(b.number.replace(/\s/g, '')));
                    })
                    .catch(defaultHandleErrorFunction);
            }
        },
        watch: {
            codesListUpdateRequired: function (val) {
                this.checkUpdateRequired();
            },
        },
        created() {
            this.checkUpdateRequired();
        }
    };

    const budgetCodesService = new BudgetCodesService();
</script>
